'
' MKROUTE.BAS   by Tommy Roeder (2:246/61)
'
' Compiled using PowerBasic v2.10e
'
'
'
' v0.06 - A '%name' in the Routing-Comment-Line of MKROUTE.CFG
'         will be translated to the name of the region.
' v0.05 - If you specify the /d-parameter (debug-mode) then
'         you will get an additional summary of unrouted regions.
' v0.04 - Added [Esc]-abortion and command-line-debug-code
'         Region-independent nodes will now be routed too
' v0.03 - Added command-line-switches and wildcard-support for
'         the nodelist-parameter. Thanx to Dieter Soltau for
'         his suggestions.
' v0.02 - Modified the source to make changes more easy.
'         Included some special treatments for possible user-errors.
'         The _number_ of regions is now limited, not longer the
'         range for the region-numbers. See variable MR.
'         Included InterMail-support in the source.
' v0.01 - First release.
'
'
$include "tr.inc" 'needed for dir-search-commands
call inithardware

v$="v0.06"       'Version
mr=50            'Maximum number of regions in the Zone to work on
mip=100          'Maximum number of independent nodes in Zone
z$="2"           'default-zone 2
n$="NODELIST.*"  'default-dir/filename for nodelist
s$="*"           'default-routing-parameter meaning ALL
c$="route-to"    'default-routing-command
o$="ROUTE.FD"    'default-output-filename
dim r$(mr),n$(mr),r(mr),n1(mip),n2(mip)

if instr(command$,"?") then rtfm
print "Parsing commandline... ";
a$=command$ : a=instr(a$,"/")
while a
 b$=mid$(a$,a+1) : b=instr(b$," ")
 if b then
  a$=mid$(b$,b+1) : b$=left$(b$,b-1)
 else
  a$=""
 end if
 select case left$(ucase$(b$),1)
  case "N"
   n$=mid$(b$,2)
  case "Z"
   z$=mid$(b$,2)
  case "S"
   s$=mid$(b$,2)
  case "R"
   c$=mid$(b$,2)
  case "O"
   o$=mid$(b$,2)
  case "D"
   debug=1
 end select
 a=instr(a$,"/")
wend
if debug then
 print
 print " Zone: "z$ : print " 'All'-string: "s$ : print " Routing-command: "c$
 print " Output-filename: "o$ : print " Nodelist-path and -filename: "n$
else
 print "Ok."
end if

print "Looking for nodelist... ";
if exists%(n$) then
 while not eodir%
  a$=direntry$
  if val(right$(a$,3))>0 then f$=a$ : exit loop
 wend
else
 print "NOT FOUND!" : end
end if
if f$="" then print "no extension .### found!" : end
ff$=f$ : a=instr(n$,"\")
if a then
 while a : b=a : a=instr(a+1,n$,"\") : wend
 f$=left$(n$,b)+f$
end if
print "Ok."

print "Opening file <"ucase$(f$)"> for input... ";
open f$ for input shared as #1
print "Ok."

print "Looking for Zone "z$"... ";
do
 a$=linp$(1)
 if eof(1) then print "not found!" : end
loop until left$(a$,6+len(z$))="Zone,"+z$+","
print "Ok."

print "Looking for Independent Nodes... ";
ip=1 : n1(1)=tnmbr(a$) : n2(1)=0
do
 a$=linp$(1)
 if a$<>";" then incr ip : n1(ip)=tnmbr(a$) : n2(ip)=nnmbr(a$)
 if eof(1) then print "unexpected end of nodelist!" : end
 if ip=mip then print "maximum number of independent nodes reached!" : exit loop
loop until a$=";"
if debug then
 print : print " Found"ip"nodes."
else
 print "Ok."
end if

print "Looking for Regions/Nets... ";
do
 a$=linp$(1)
 if left$(a$,7)="Region," then
  incr r
  r$=mid$(a$,8) : r$=left$(r$,instr(r$,",")-1)
  if debug then
   print : print r$":";
  else
   locate ,29 : print "R"r$;
  end if
  a=tnmbr(a$) : i$=" "
  for i=1 to ip
   if a=n1(i) then
    i$=i$+z$+":"+z$+"/"+right$(str$(n2(i)),len(str$(n2(i)))-1)+" "
   end if
  next i
  r(r)=val(r$)
  r$(r)=c$+i$+z$+":"+r$+"/"+s$
  n$(r)=mid$(a$,instr(8,a$,",")+1)
  n$(r)=left$(n$(r),instr(n$(r),",")-1)
  for i=1 to len(n$(r))
   if mid$(n$(r),i,1)="_" then mid$(n$(r),i)=" "
  next i
 elseif left$(a$,5)="Host," then
  n$=mid$(a$,6) : n$=left$(n$,instr(n$,",")-1)
  if debug then
   print " "n$;
  else
   locate ,31+len(r$) : print "N"n$;spc(5);
  end if
  r$(r)=r$(r)+" "+z$+":"+n$+"/"+s$
 end if
loop until left$(a$,5)="Zone," or eof(1)
if not debug then locate ,29 : print "Ok."spc(40)

close #1

print "Opening file <MKROUTE.CFG> for input... ";
open "mkroute.cfg" for input shared as #1
print "Ok."

print "Opening file <"ucase$(o$)"> for output... ";
open o$ for output as #2
print "Ok."

print #2,"; Generated by MKROUTE on "date$" "time$
print #2,"; Source: "ucase$(ff$)
print #2,";"
print #2,"; DO NOT CHANGE THIS FILE! CHANGE MKROUTE.CFG INSTEAD!!!"
print #2,";"
print #2,

print "Generating file <"ucase$(o$)"> from file <MKROUTE.CFG>... ";
if debug then print
while not eof(1)
 a$=linp$(1)
 if left$(a$,3)="; R" and instr(3,a$," ") then
  r$=mid$(a$,4) : r$=left$(r$,instr(r$," ")-1) : r=val(r$)
  for i=1 to mr : if r(i)<>r then next i : exit if
  if r=0 or r>mr or r$(i)="" then exit if
  t$=mid$(a$,instr(3,a$," ")+1)
  a=instr(t$," ")-1 : if a=-1 then a=len(t$)
  t$=left$(t$,a)
  if debug then print " Route Region "r$" via "t$"... ";
  b$=left$(r$(i),len(c$)+1)+t$+mid$(r$(i),len(c$)+1)
  r$(i)="x"
  a=instr(ucase$(a$),"%NAME%")
  if a then a$=left$(a$,a-1)+n$(i)+mid$(a$,a+6)
  print #2,a$ : a$=""
  print #2,b$
  if debug then print "Ok."
 end if
 if a$<>"" then print #2,a$
wend
if debug then
 print " Unrouted Regions in Zone "z$":";
 for i=1 to mr
  if r$(i)<>"" and r$(i)<>"x" then
   a$=right$(str$(r(i)),len(str$(r(i)))-1)
   print " R"a$;
  end if
 next i
 print
else
 print "Ok."
end if

print #2,
print #2,";"
print #2,"; DO NOT CHANGE THIS FILE! CHANGE MKROUTE.CFG INSTEAD!!!"
print #2,";"

close #2
close #1
print "MKROUTE done."
end

function linp$(a)
 line input #a,a$
 if inkey$=chr$(27) then print " * Aborted! *" : end
 linp$=a$
end function

function tnmbr(a$)
 for i=1 to 5 : a=instr(a+1,a$,",") : next i
 tnmbr=val(mid$(a$,a+1,instr(a+1,a$,"-")-a-1))
end function

function nnmbr(a$)
 a=instr(a$,",")+1
 nnmbr=val(mid$(a$,a,instr(a,a$,",")-a))
end function

rtfm:
 print "MKROUTE "v$"   by Tommy Roeder (2:246/61)"
 print "This program generates a routing-file for FrontDoor/InterMail/Squish."
 print
 print "Syntax: MKROUTE <parameterlist>"
 print
 print " Parameter      Meaning                          Default"
 print " ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
 print " /N<Dir/Name>   your Nodelist-dir and name       NODELIST.*"
 print " /Z<Zone>       Zone to work on                  2"
 print " /S<String>     routing-String meaning 'all'     * (for FD)"
 print " /R<String>     Route-command                    route-to (for FD)"
 print " /O<Filename>   Output-filename                  ROUTE.FD (for FD)"
 print " /D             Debug-mode (more screen-output)  disabled"
 print
 print "Example: MKROUTE /nd:\nodelist\nodelist.* /z1 /sAll /oc:\im\route.im"
end
